#!/usr/bin/env python
#
# Copyright 2004 Free Software Foundation, Inc.
# 
# This file is part of GNU Radio
# 
# GNU Radio is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# GNU Radio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with GNU Radio; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
# 

from gnuradio import gr, gr_unittest
import rds

class qa_rds (gr_unittest.TestCase):

    def setUp (self):
        self.fg = gr.flow_graph ()

    def tearDown (self):
        self.fg = None

#  this test is broken diff_decoder outputs bools and there
#   is no vector_source_bool
#
#    def test_002_diff_decoder (self):
#	src_data = 	  (0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0)
#	expected_result = (0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1)
#	src = gr.vector_source_s (src_data)
#	dut = rds.diff_decoder ()
#	dst = gr.vector_sink_s ()
#
#	self.fg.connect (src, dut)
#	self.fg.connect (dut, dst)
#	self.fg.run ()
#	result_data = dst.data()
#	self.assertEqual (expected_result, result_data)

    def test_003_freq_divider (self):
        src_data = 	(-1, 1, -1, 1, -1, 1, -1, 1, -1, 1, -1, 1, -1, 1)

	expected_data = (1,  1, -1, -1, 1, 1, -1, -1, 1, 1, -1, -1, 1, 1)
	src = gr.vector_source_f (src_data)
	dut = rds.freq_divider(3)
	dst = gr.vector_sink_f ()

	self.fg.connect(src, dut)
	self.fg.connect(dut, dst)

	self.fg.run()

	result_data = dst.data()

	print "Resulted data: " 
	print result_data
	print "\n"

        
if __name__ == '__main__':
    gr_unittest.main ()
